package org.processmining.models.graphbased.directed.shapes;

import java.awt.geom.GeneralPath;
import java.awt.geom.RoundRectangle2D;

import org.processmining.models.graphbased.directed.yawlperformancediagram.YPDTask;
import org.processmining.models.shapes.AbstractShape;

/**
 * @author David Piessens
 * @email d.a.m.piessens@student.tue.nl
 * @version May 29, 2010
 */
public class YPDTaskShape extends AbstractShape {
	@SuppressWarnings("unused")
	private YPDTask visualizedYPDTask;
	
	private double paddingFromBoxToText = 0.0;
	private double branchingBoxWidth = 0.0;
	
	@SuppressWarnings("unused")
	private YPDTaskShape(){};
	
	public YPDTaskShape(YPDTask visualizedYPDTask, double paddingFromBoxToText, double branchingBoxWidth){
		this.visualizedYPDTask = visualizedYPDTask;
		this.paddingFromBoxToText = paddingFromBoxToText;
		this.branchingBoxWidth = branchingBoxWidth;
	}
	
	public GeneralPath getPath(double x, double y, double width, double height) {
		/**
		 * SCALE HEIGHT AND WIDTH OF THIS NODE
		 */
		double m = Math.max(width, height) * .125;
		
		// Width and height have correct ratio;
		GeneralPath path = new GeneralPath();

		// main border
		java.awt.Shape rect = new RoundRectangle2D.Double(x, y, width, height, m, m);
		path.append(rect, false);
		
		// line between split boxes and main content
		path.moveTo(new Float(x + paddingFromBoxToText + branchingBoxWidth + paddingFromBoxToText), (float)y);
		path.lineTo(new Float(x + paddingFromBoxToText + branchingBoxWidth + paddingFromBoxToText), new Float(y + height));
		path.closePath();
		
		// line between main content and join boxes
		path.moveTo(new Float(x - paddingFromBoxToText - branchingBoxWidth - paddingFromBoxToText + width), (float)y);
		path.lineTo(new Float(x - paddingFromBoxToText - branchingBoxWidth - paddingFromBoxToText + width), new Float(y + height));
		path.closePath();

		return path;
	}

}
