
package org.processmining.models.graphbased.directed.yawl;

import java.util.LinkedList;
import java.util.List;

import org.processmining.framework.util.Pair;

/**
* @author David Piessens
* @email d.a.m.piessens@student.tue.nl
* @version May 29, 2010
*/
public class YawlConformanceResult {
	// total fitness mode
	public static String TOTAL_MODE_TRACE_FITNESS = "Trace Fitness - TF";
	public static String TOTAL_MODE_AVERAGE_TRACE_FITNESS_EL = "Average Trace Fitness (event level) - TF";
	public static String TOTAL_MODE_AVERAGE_TRACE_FITNESS_TEL = "Average Trace Fitness (event class level) - TF";
	public static String TOTAL_MODE_ABSOLUTE_FITNESS_EL = "Absolute Fitness (event level) - TF";
	public static String TOTAL_MODE_ABSOLUTE_FITNESS_TEL = "Absolute Fitness (event class level) - TF";

	// replay fitness mode
	public static String REPLAY_MODE_TRACE_FITNESS = "Trace Fitness - RF";
	public static String REPLAY_MODE_AVERAGE_TRACE_FITNESS_EL = "Average Trace Fitness (event level) - RF";
	public static String REPLAY_MODE_AVERAGE_TRACE_FITNESS_TEL = "Average Trace Fitness (event class level) - RF";
	public static String REPLAY_MODE_ABSOLUTE_FITNESS_EL = "Absolute Fitness (event level) - RF";
	public static String REPLAY_MODE_ABSOLUTE_FITNESS_TEL = "Absolute Fitness (event class level) - RF";

	// coverage fitness mode
	public static String COVERAGE_MODE_TRACE_FITNESS = "Trace Fitness - CF";
	public static String COVERAGE_MODE_AVERAGE_TRACE_FITNESS_EL = "Average Trace Fitness (event level) - CF";
	public static String COVERAGE_MODE_AVERAGE_TRACE_FITNESS_TEL = "Average Trace Fitness (event class level) - CF";
	public static String COVERAGE_MODE_ABSOLUTE_FITNESS_EL = "Absolute Fitness (event level) - CF";
	public static String COVERAGE_MODE_ABSOLUTE_FITNESS_TEL = "Absolute Fitness (event class level) - CF";
	
	// data variable
	private List<Pair<String, Double>> conformanceValues = new LinkedList<Pair<String,Double>>();

	public YawlConformanceResult(){	}
	
	public void addConformanceValue(String metricName, double value){
		Pair<String, Double> confValue = new Pair<String, Double> (metricName, value);
		this.conformanceValues.add(confValue);
	}
	
	public double getConformanceValue(String metricName){
		for (Pair<String, Double> pair : conformanceValues){
			if (pair.getFirst().equals(metricName)){
				return pair.getSecond();
			}
		}
		return -1;
	}
	
	public void removeConformanceValue(String metricName){
		int i = 0;
		while (i < conformanceValues.size()){
			if (conformanceValues.get(i).getFirst().equals(metricName)){
				conformanceValues.remove(i);
				break;
			}
		}
	}
	
	/**
	 * @return the conformanceValues
	 */
	public List<Pair<String, Double>> getConformanceValues() {
		return conformanceValues;
	}

	/**
	 * @param conformanceValues the conformanceValues to set
	 */
	public void setConformanceValues(List<Pair<String, Double>> conformanceValues) {
		this.conformanceValues = conformanceValues;
	}

	public void clear(){
		conformanceValues.clear();
	}
}
