package org.processmining.models.graphbased.directed.yawl;

import java.util.LinkedList;
import java.util.List;

import org.processmining.framework.util.Pair;

/**
* @author David Piessens
* @email d.a.m.piessens@student.tue.nl
* @version May 29, 2010
*/
public class YawlPerformanceResult {
	public static String TOTAL_THROUGHPUT = "Average Throughput Time (s)";
	public static String COMPLETED_CASES = "Completed Cases";
	
	// data variable
	private List<Pair<String, Double>> performanceValues = new LinkedList<Pair<String,Double>>();

	public YawlPerformanceResult(){	}
	
	public void addPerformanceValue(String metricName, double value){
		Pair<String, Double> confValue = new Pair<String, Double> (metricName, value);
		this.performanceValues.add(confValue);
	}
	
	public double getConformanceValue(String metricName){
		for (Pair<String, Double> pair : performanceValues){
			if (pair.getFirst().equals(metricName)){
				return pair.getSecond();
			}
		}
		return -1;
	}
	
	public void removeConformanceValue(String metricName){
		int i = 0;
		while (i < performanceValues.size()){
			if (performanceValues.get(i).getFirst().equals(metricName)){
				performanceValues.remove(i);
				break;
			}
		}
	}
	
	/**
	 * @return the conformanceValues
	 */
	public List<Pair<String, Double>> getPerformanceValues() {
		return performanceValues;
	}

	/**
	 * @param conformanceValues the conformanceValues to set
	 */
	public void setPerformanceValues(List<Pair<String, Double>> performanceValuesValues) {
		this.performanceValues = performanceValuesValues;
	}

	public void clear(){
		performanceValues.clear();
	}
}
