package org.processmining.models.graphbased.directed.yawl.animation;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import org.processmining.framework.util.Pair;

/**
* @author David Piessens
* @email d.a.m.piessens@student.tue.nl
* @version May 29, 2010
*/
public class ArcKeyFrame extends KeyFrame{
	private Date latestEndTime = null;
	private List<Pair<Date,Date>> listTimePair;
	
	public ArcKeyFrame(int numOfActivation, Date from, Date to){
		super(0, from);
		this.listTimePair = new LinkedList<Pair<Date,Date>>();
		this.latestEndTime = to;
		this.addTimePair(from, to);
	}
	
	public List<Pair<Date,Date>> getTimePair(){
		return listTimePair;
	}
	
	public void setTimePair(List<Pair<Date,Date>> listTimePair){
		this.listTimePair = listTimePair;
	}
	
	public void addTimePair(Date from, Date to){
		// always insert it 
		Pair<Date, Date> newPair = new Pair<Date, Date>(from, to);
		this.listTimePair.add(newPair);
	
		// update latestEndTime
		if (to.after(latestEndTime)){
			this.latestEndTime = to;
		}
		
		// increment number of activation
		this.incrementNumOfActivation();
	}

	/**
	 * @param activeAnimations
	 */
	public void addActiveAnimations(List<Pair<Date, Date>> activeAnimations) {
		this.listTimePair.addAll(activeAnimations);
	}
	
	public Date getLatestEndTime(){
		return this.latestEndTime;
	}
	
	public void setLatestEndTime(Date latestEndTime){
		this.latestEndTime = latestEndTime;
	}
}
