package org.processmining.models.graphbased.directed.yawlperformancediagram;

/**
* @author David Piessens
* @email d.a.m.piessens@student.tue.nl
* @version May 29, 2010
*/
public class YPDFactory {

	private YPDFactory() {}

	/**
	 * Create new YPD
	 * @param label
	 * @return
	 */
	public static YPD newYPD(String label) {
		return new YPDImpl(label);
	}
	
	/**
	 * Clone an YPD
	 * @param diagram
	 * @return
	 */
	public static YPD cloneYPD(YPD diagram) {
		YPDImpl newDiagram = new YPDImpl(diagram.getLabel());
		newDiagram.cloneFrom(diagram);
		return newDiagram;
	}
}
