package org.processmining.models.graphbased.directed.yawlperformancediagram;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.directed.AbstractDirectedGraph;
import org.processmining.models.shapes.Decorated;
import org.processmining.models.shapes.Ellipse;

/**
* @author David Piessens
* @email d.a.m.piessens@student.tue.nl
* @version May 29, 2010
*/
public class YPDOutputCondition extends YPDNode implements Decorated {

	private static final long serialVersionUID = 1L;
	private static final Color fillColor = new Color(255,240,240);

	public YPDOutputCondition(AbstractDirectedGraph<YPDNode, YPDEdge<? extends YPDNode, ? extends YPDNode>> net, String label) {
		super(net, label);
		
		getAttributeMap().put(AttributeMap.LABEL, label);
		getAttributeMap().put(AttributeMap.SHAPE, new Ellipse());
		getAttributeMap().put(AttributeMap.SQUAREBB, true);
		getAttributeMap().put(AttributeMap.RESIZABLE, false);
		getAttributeMap().put(AttributeMap.SIZE, new Dimension(40, 40));
		getAttributeMap().put(AttributeMap.SHOWLABEL, false);
	}

	public void decorate(Graphics2D g2d, double x, double y, double width, double height) {
		 
		g2d.setColor(fillColor);
	
	   // super.fillVertex(g2d, size);
	    g2d.setColor(Color.RED);
	    g2d.fillRect(((int) Math.round(width/4)),
	    		((int) Math.round(height/4)) + 1,
	    		(int) Math.round(width/2),
	    		(int) Math.round(height/2));
	    g2d.setColor(Color.black);
	    g2d.drawRect(((int) Math.round(width/4)),
	    		((int) Math.round(height/4)) + 1,
	    		(int) Math.round(width/2 - 1),
	    		(int) Math.round(height/2 - 1));
	   // super.drawVertex(g2d, size);	
	}

}
